
Database - Feature #1890

upgrade to the latest stable PLJava and ensure that it is available on all target platforms

10/31/2012 05:03 PM - Greg Shah

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 100%

Category:  Estimated time: 32.00 hours

Target version: Cleanup and Stablization for Server

Features

  

billable: No vendor_id: GCD

Description

History

#1 - 10/31/2012 05:04 PM - Greg Shah

Both 32-bit and 64-bit must be supported. Linux, Solaris and Windows all must be supported.

#2 - 02/15/2013 03:22 PM - Eric Faulhaber

From the PL/Java mailing list (potentially helpful for Linux 64bit and Java 7)...

Send Pljava-dev mailing list submissions to

 pljava-dev@pgfoundry.org

To subscribe or unsubscribe via the World Wide Web, visit

 http://lists.pgfoundry.org/mailman/listinfo/pljava-dev

or, via email, send a message with subject or body 'help' to

 pljava-dev-request@pgfoundry.org

You can reach the person managing the list at

 pljava-dev-owner@pgfoundry.org

When replying, please edit your Subject line so it is more specific

than "Re: Contents of Pljava-dev digest..."

Today's Topics:

1. Building / installing for CentOS or Fedora (eggyknap)

   2. Re: Building / installing for CentOS or Fedora (Christian Hammers)

   3. Re: Building / installing for CentOS or Fedora (eggyknap)

   4. Re: Building / installing for CentOS or Fedora (eggyknap)

   5. Re: Building / installing for CentOS or Fedora (eggyknap)

   6. Re: Building / installing for CentOS or Fedora (Christian Hammers)

 

Message: 1

Date: Fri, 15 Feb 2013 08:26:01 -0700

From: eggyknap <eggyknap@gmail.com>

To: pljava-dev@pgfoundry.org

Subject: [Pljava-dev] Building / installing for CentOS or Fedora

Message-ID: <511e538b.4553420a.51be.1fa8@mx.google.com>

Content-Type: text/plain; charset="us-ascii"

Having just read the recent mailing list archives, I'm guessing this isn't a

resolved problem. I'm trying to install PL/Java on Postgres 9.2 with, ideally,

Java 1.5 or 1.6 (though 1.7 might not cause anyone heartburn either). Server

is Linux, x64.

I've tried building from source on my own similar box (Fedora, not CentOS, but

otherwise equivalent software) to no avail:
[josh@eddie ~/devel/pljava]$ export USE_LD_RPATH=4

[josh@eddie ~/devel/pljava]$ make

make

1

: Entering directory `/home/josh/devel/pljava/build/classes/pljava'

make

1

: /home/josh/devel/pljava/src/java/pljava/Makefile: No such file or

directory

make

1

: * No rule to make target

`/home/josh/devel/pljava/src/java/pljava/Makefile'.  Stop.

make

1

: Leaving directory `/home/josh/devel/pljava/build/classes/pljava'

make: * [pljava_all] Error 2

It looks like that's already been seen on this list, but I didn't find

sufficient detail in the lists to understand how to get past it. Help?

I'm not wedded to the idea of buiding from source; I just want it installed

and working. If there's a package somewhere, that would be lovely, but I

gather that's unlikely.

--

Joshua Tolley / eggyknap

End Point Corporation

http://www.endpoint.com

-------------- next part --------------

A non-text attachment was scrubbed...

Name: not available

Type: application/pgp-signature

Size: 836 bytes

Desc: not available

URL: <http://lists.pgfoundry.org/pipermail/pljava-dev/attachments/20130215/a01b7627/attachment-0001.bin>

Message: 2

Date: Fri, 15 Feb 2013 18:24:57 +0100

From: Christian Hammers <ch@lathspell.de>

To: eggyknap <eggyknap@gmail.com>

Cc: pljava-dev@pgfoundry.org

Subject: Re: [Pljava-dev] Building / installing for CentOS or Fedora

Message-ID: <20130215182457.455342b1@sys-251.netcologne.de>

Content-Type: text/plain; charset=UTF-8

Hello

One quick way to get it running is using https://github.com/lathspell/pljava.git

which builds everything with just "mvn install".

The official GIT repository has IIRC not yet applied the patches for Java 1.7

and the hellblazer repository works with Java 1.7 but does not compile the C

sources automatically.

bye,

christian

On Fri, 15 Feb 2013 08:26:01 -0700

eggyknap <eggyknap@gmail.com> wrote:

Having just read the recent mailing list archives, I'm guessing this isn't a

resolved problem. I'm trying to install PL/Java on Postgres 9.2 with, ideally,

Java 1.5 or 1.6 (though 1.7 might not cause anyone heartburn either). Server

is Linux, x64.

I've tried building from source on my own similar box (Fedora, not CentOS, but

otherwise equivalent software) to no avail:

[josh@eddie ~/devel/pljava]$ export USE_LD_RPATH=4

[josh@eddie ~/devel/pljava]$ make

make

1

: Entering directory `/home/josh/devel/pljava/build/classes/pljava'

make

1

: /home/josh/devel/pljava/src/java/pljava/Makefile: No such file or

directory

make

1

: * No rule to make target

`/home/josh/devel/pljava/src/java/pljava/Makefile'.  Stop.

make

1

: Leaving directory `/home/josh/devel/pljava/build/classes/pljava'

make: * [pljava_all] Error 2

It looks like that's already been seen on this list, but I didn't find

sufficient detail in the lists to understand how to get past it. Help?
I'm not wedded to the idea of buiding from source; I just want it installed

and working. If there's a package somewhere, that would be lovely, but I

gather that's unlikely.

--

Joshua Tolley / eggyknap

End Point Corporation

http://www.endpoint.com
eggyknap@gmail.com> To: Christian Hammers <ch@lathspell.de> Cc: pljava-dev@pgfoundry.org Subject: Re: [Pljava-dev] Building / installing for

CentOS or Fedora Message-ID: <511e77d5.c1fb440a.4c4a.ffff87cc@mx.google.com> Content-Type: text/plain; charset="us-ascii" On Fri, Feb 15,

2013 at 06:24:57PM +0100, Christian Hammers wrote:

One quick way to get it running is using https://github.com/lathspell/pljava.git

which builds everything with just "mvn install".

 

Awesome... except that I get this:

[WARNING] The POM for

org.apache.maven.plugins:maven-nar-plugin:jar:2.1-SNAPSHOT is missing, no

dependency information available

[ERROR] The build could not read 1 project -> [Help 1]

[ERROR]

[ERROR]   The project org.postgresql:pljava-so:0.0.1-SNAPSHOT

(/home/josh/devel/pljava-build/pljava-so/pom.xml) has 2 errors

[ERROR]     Unresolveable build extension: Plugin

org.apache.maven.plugins:maven-nar-plugin:2.1-SNAPSHOT or one of its

dependencies could not be resolved: Could not find artifact

org.apache.maven.plugins:maven-nar-plugin:jar:2.1-SNAPSHOT -> [Help 2]

[ERROR]     Unknown packaging: nar @ line 14, column 16

I don't speak Maven very well, but it seems I need a special maven-nar-plugin

version including some of your own changes, and I'm guessing the problem

involves getting that version. How do I get around that? #begging-for-help

Thanks.

--

Joshua Tolley / eggyknap

End Point Corporation

http://www.endpoint.com

-------------- next part --------------

A non-text attachment was scrubbed...

Name: not available

Type: application/pgp-signature

Size: 836 bytes

Desc: not available

URL: <http://lists.pgfoundry.org/pipermail/pljava-dev/attachments/20130215/a8cf6e90/attachment-0001.bin>

Message: 4

Date: Fri, 15 Feb 2013 11:21:18 -0700

From: eggyknap <eggyknap@gmail.com>

To: Christian Hammers <ch@lathspell.de>

Cc: pljava-dev@pgfoundry.org

Subject: Re: [Pljava-dev] Building / installing for CentOS or Fedora

Message-ID: <511e7ca1.444b420a.4533.7851@mx.google.com>

Content-Type: text/plain; charset="us-ascii"

On Fri, Feb 15, 2013 at 06:24:57PM +0100, Christian Hammers wrote:

One quick way to get it running is using https://github.com/lathspell/pljava.git

which builds everything with just "mvn install".
The official GIT repository has IIRC not yet applied the patches for Java 1.7

and the hellblazer repository works with Java 1.7 but does not compile the C

sources automatically.

 

Perhaps by installing your version of the nar plugin from github, I've

succeeded. I'll test this out. Thanks.

--

Joshua Tolley / eggyknap

End Point Corporation

http://www.endpoint.com

-------------- next part --------------

A non-text attachment was scrubbed...

Name: not available

Type: application/pgp-signature

Size: 836 bytes

Desc: not available

URL: <http://lists.pgfoundry.org/pipermail/pljava-dev/attachments/20130215/eab43763/attachment-0001.bin>

Message: 5

Date: Fri, 15 Feb 2013 11:55:44 -0700

From: eggyknap <eggyknap@gmail.com>

To: Christian Hammers <ch@lathspell.de>

Cc: pljava-dev@pgfoundry.org

Subject: Re: [Pljava-dev] Building / installing for CentOS or Fedora

Message-ID: <511e84bb.a2e8440a.3a40.ffff89f0@mx.google.com>

Content-Type: text/plain; charset="us-ascii"

On Fri, Feb 15, 2013 at 11:21:18AM -0700, eggyknap wrote:

Perhaps by installing your version of the nar plugin from github, I've

succeeded. I'll test this out. Thanks.

 

Well, it's a qualified success. After running maven, I couldn't find any

pljava.so or pljava.jar files anywhere, so I went into various subdirectories

and ran ant manually, which created some files named similarly to what I was

looking for. I put them manually into the PostgreSQL $libdir, because I liked

that method better than fiddling with dynamic_library_path, and after changing

LD_LIBRARY_PATH so postgres could find libjvm.so, was able to create the

language successfully.

Now I'm loading the examples, and get this:

pljava=# select

sqlj.install_jar('file:///home/josh/devel/pljava-build/pljava-examples/target/pljava-examples-0.0.1-SNAPSHOT.jar',

'samples', true);

WARNING:  java.lang.NoClassDefFoundError:

org/postgresql/pljava/internal/Backend

ERROR:  Unable to load class org/postgresql/pljava/internal/Backend using

CLASSPATH

'-Djava.class.path=target/lib//pljava.jar:/etc/alternatives/java_sdk/lib/management-agent.jar:/etc/alternatives/java_sdk/lib/tools.jar'

I'll see if I can figure out how to make that target/lib/pljava.jar classpath

absolute, and ... something meaninful. I expected maven to create nicely

packaged .so and .jar files for me, and it didn't, which suggests I'm doing

something else wrong.

--

Joshua Tolley / eggyknap

End Point Corporation

http://www.endpoint.com

-------------- next part --------------

A non-text attachment was scrubbed...

Name: not available

Type: application/pgp-signature

Size: 836 bytes

Desc: not available

URL: <http://lists.pgfoundry.org/pipermail/pljava-dev/attachments/20130215/18c561cc/attachment-0001.bin>
Message: 6

Date: Fri, 15 Feb 2013 20:11:48 +0100

From: Christian Hammers <ch@lathspell.de>

To: eggyknap <eggyknap@gmail.com>

Cc: pljava-dev@pgfoundry.org

Subject: Re: [Pljava-dev] Building / installing for CentOS or Fedora

Message-ID: <20130215201148.32266079@james.intern>

Content-Type: text/plain; charset="us-ascii"

Am Fri, 15 Feb 2013 11:55:44 -0700

schrieb eggyknap <eggyknap@gmail.com>:

On Fri, Feb 15, 2013 at 11:21:18AM -0700, eggyknap wrote:

Perhaps by installing your version of the nar plugin from github,

I've succeeded. I'll test this out. Thanks.

 

Well, it's a qualified success. After running maven, I couldn't find

any pljava.so or pljava.jar files anywhere

 

Maven calls the file slightly different:

pljava-so/target/nar/pljava-so-0.0.1-SNAPSHOT-amd64-Linux-gpp-shared/lib/amd64-Linux-gpp/shared/libpljava-so-0.0.1-SNAPSHOT.so

Running "mvn deploy" as root inside the pljava-so directory will

automatically copy it to /usr/lib/postgresql/9.2/main/pljava.so (or

whereever it belongs). Has still to be documented though

so I went into various

subdirectories and ran ant manually, which created some files named

similarly to what I was looking for. I put them manually into the

PostgreSQL $libdir, because I liked that method better than fiddling

with dynamic_library_path, and after changing LD_LIBRARY_PATH so

postgres could find libjvm.so, was able to create the language

successfully.

Now I'm loading the examples, and get this:

pljava=# select

sqlj.install_jar('file:///home/josh/devel/pljava-build/pljava-examples/target/pljava-examples-0.0.1-SNAPSHOT.jar',

'samples', true);

WARNING:  java.lang.NoClassDefFoundError:

org/postgresql/pljava/internal/Backend

ERROR:  Unable to load class org/postgresql/pljava/internal/Backend

using CLASSPATH

'-Djava.class.path=target/lib//pljava.jar:/etc/alternatives/java_sdk/lib/management-agent.jar:/etc/alternatives/java_sdk/lib/tools.jar'

I'll see if I can figure out how to make that target/lib/pljava.jar

classpath absolute, and ... something meaninful. I expected maven to

create nicely packaged .so and .jar files for me, and it didn't,

which suggests I'm doing something else wrong.

 

The Backend class is part of pljava-jdbc so I assume that you did not

add the following lines (paths adjusted!) to your

/etc/postgresql/9.2/main/postgresql.conf:

pljava.classpath =

'.../pljava-api/target/pljava-api-0.0.1-SNAPSHOT.jar:.../pljava-jdbc/target/pljava-jdbc-0.0.1-SNAPSHOT.jar'

pljava.statement_cache_size = 10 pljava.release_lingering_savepoints =

true pljava.vmoptions = '-Xmx64M'

pljava.debug = false

More about this can be read in docs/userguide.html.

bye,
christian

-------------- next part --------------

A non-text attachment was scrubbed...

Name: signature.asc

Type: application/pgp-signature

Size: 198 bytes

Desc: not available

URL: <http://lists.pgfoundry.org/pipermail/pljava-dev/attachments/20130215/5dd9b994/attachment.bin>

_______________________________________

Pljava-dev mailing list

Pljava-dev@pgfoundry.org

http://lists.pgfoundry.org/mailman/listinfo/pljava-dev

End of Pljava-dev Digest, Vol 103, Issue 7 

#3 - 05/02/2013 10:32 PM - Eric Faulhaber

- Status changed from New to Closed

Constantin completed this as part of updating the regression testing environment (#2104).

#4 - 12/02/2014 09:00 AM - Eric Faulhaber

- % Done changed from 0 to 100

#5 - 11/16/2016 12:06 PM - Greg Shah

- Target version changed from Milestone 11 to Cleanup and Stablization for Server Features
